Page MenuHomePhabricator

simplemerge: stop merging file flags
ClosedPublic

Authored by martinvonz on Dec 7 2021, 12:02 PM.

Details

Summary

As 384df4db6520 (merge: merge file flags together with file content,
2013-01-09) explains, we shouldn't do a 3-way merge of the
symlink. However, since 84614212ae39 (flags: actually merge flags in
simplemerge, 2020-05-16), we do that in
simplemerge.simplemerge(). What's more, the merging of the
executable flag there isn't actually necessary; it was made a no-op by
the very next commit, i.e. 4234c9af515d (flags: read flag from
dirstate/disk for workingcopyctx (issue5743), 2020-05-16).

I found the overall flag-merging code (not the bit in
simplemerge.py) very hard to follow, but I think I now finally
understand how it works. mergestate.resolve() calculates the merged
file flags and sets them on the local side of the merge (confusingly
by calling _restore_backup()). Then it calls
filemerge.filemerge(), which in turn calls
simplemerge.simplemerge() (if premerge is enabled). That means that
the flags on the local side fcs.flags() are already correct when the
flag-merging code in simplemerge.simplemerge() runs. Interestingly,
that code still works when the local side already has the merged
value, it just doesn't change the value. Here's a truth table to
explain why:

BLOMCAR
0000000
0011111
0101011
0111111
1000000
1010000
1100000
1111101

B: Base
L: Local
O: Other
M: Merged flags from mergestate.resolve(), i.e. what's called "local"

when we get to `simplemerge.simplemerge()`

C: commonflags in simplemerge.simplemerge(), i.e. M & O
A: addedflags in simplemerge.simplemerge(), i.e. (M ^ O) - B
R: Re-merged flags simplemerge.simplemerge(), i.e. C | A

As you can see, the re-merged flags are always unchanged compared to
the initial merged flags (R equals M).

Therefore, this patch effectively backs out 84614212ae39. (I might
later refactor this code to have the flags explicitly passed in.)

simplemerge.simplemerge() is also called from
contrib/simplemerge.py, but that code never passes any flags.

Diff Detail

Repository
rHG Mercurial
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

martinvonz created this revision.Dec 7 2021, 12:02 PM

I'll have a deeper look to @martinvonz comment to double check what is going on here.

I'll have a deeper look to @martinvonz comment to double check what is going on here.

👍

marmoute accepted this revision.Dec 16 2021, 3:26 PM

Thanks for your patience/

I had a deeper looks and that seems correct. I agree that Martin that this logic is messy and probably need a refactoring. If you could follow up with a comment pointing out what is going on flag-wise in simplemerge.py, that would be great.

Thanks for your patience/

No problem, this code took me a while to understand.

If you could follow up with a comment pointing out what is going on flag-wise in simplemerge.py, that would be great.

For now, I just added that comment saying that the flag-merging happens in mergestate.resolve() (I added that already before your request, I mean). There isn't any flag-merging going on in simplemerge.py after this patch. What would the comment you're thinking of say?

I have considered having simplemerge() just return the merged text instead. If I do that, it becomes obvious that flags are not merged and I'll remove the comment added in this patch.

Thanks for your patience/

No problem, this code took me a while to understand.

If you could follow up with a comment pointing out what is going on flag-wise in simplemerge.py, that would be great.

For now, I just added that comment saying that the flag-merging happens in mergestate.resolve() (I added that already before your request, I mean). There isn't any flag-merging going on in simplemerge.py after this patch. What would the comment you're thinking of say?

I was thinking about that comment. Thanks goes to your past self to fullfilling this request before I phrased it :-)

Alphare accepted this revision.Dec 17 2021, 5:54 AM
Alphare added a subscriber: Alphare.

Looks like we're happy!

This revision is now accepted and ready to land.Dec 17 2021, 5:54 AM
This revision was automatically updated to reflect the committed changes.